##############################
#Multilevel workshop I Examples
#June 20/21, 2013
#StatLab@UVa Library
#Michele Claibourn
##############################

#Implementation and Interpretation
#Multilevel Model Estimation
#Load High School and Beyond Data

#Load packages
library(lme4)
library(foreign)

#Load data
schools <- read.dta('http://www.people.virginia.edu/~mpc8t/Multilevel1Workshop/schools.dta')

# Look at the first 10 rows of data
head(schools)
tail(schools)

# Examine the data set briefly
dim(schools)
summary(schools)

# Estimate a one-way ANOVA with random effects
school.anova <- lmer(mathach ~ 1 + (1 | school), data=schools)
summary(school.anova)
coef(school.anova)

#The intra-class correlation
ICC <- 8.614/(8.614+39.148)
ICC

#Estimate a random-intercept model
school.rim <- lmer(mathach ~ cses + (1 | school), data=schools)
summary(school.rim)

# Estimate a random coefficient model 
school.rcm <- lmer(mathach ~ cses + (cses | school), data=schools)
summary(school.rcm)

#Is random coefficient statistically significant?
anova(school.rcm, school.rim)

# Estimate the full model
school.lme <- lmer(mathach ~ catholic*cses + (cses | school), data=schools)
summary(school.lme)

#PRE: Intercept Variance
PREint <- 1 - (6.75003/8.6816)
PREint
#PRE: Coefficient variance
PREcoef <- 1 - (0.26576/0.6940)
PREcoef

#The Linear Mixed-Effects Model
school2.lme <- lmer(mathach ~ catholic*cses + meanses*cses + (cses | school), data=schools)
summary(school2.lme)
